=== debian/changelog ===
mathgl (2.2.2.1-3ubuntu1) wily; urgency=medium

  * Add debian/patches/udav-link-X11.patch: udav/udav_wnd.cpp calls
    XInitThreads(), so we must link to -lX11. Fixes FTBFS.
    (Closes: #788776)
  * Rebuild against libwx*-0v5.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 10 Aug 2015 15:05:13 +0200

mathgl (2.2.2.1-3build1) vivid; urgency=medium

  * Rebuild against libhdf5-8.

 -- Colin Watson <cjwatson@ubuntu.com>  Thu, 06 Nov 2014 12:57:22 +0000

mathgl (2.2.2.1-3) unstable; urgency=medium

  * Re-enable Architecture=any on all arch dependent binaries
  * Edit several Conflicts and Replaces lines in d/control

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sun, 20 Apr 2014 09:53:11 +0300

mathgl (2.2.2.1-2) unstable; urgency=medium

  * Exclude kfreebsd-i386 from build arch due to FTBFS

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Mon, 24 Mar 2014 12:20:56 +0200

mathgl (2.2.2.1-1) unstable; urgency=medium

  * Imported Upstream version 2.2.2.1

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Mon, 24 Mar 2014 01:00:27 +0200

mathgl (2.2.2+svn930-2) unstable; urgency=medium

  * Build against newer libwxgtk3.0 (Closes: #741710)

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sun, 16 Mar 2014 09:02:42 +0200

mathgl (2.2.2+svn930-1) unstable; urgency=medium

  * Imported Upstream version 2.2.2+svn930 (Closes: #741131)

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sat, 15 Mar 2014 12:08:13 +0200

mathgl (2.2.1+svn921-1) unstable; urgency=low

  * Imported Upstream version 2.2.1+svn921 (Closes: #737110, #737437)
  * Fix DEP5 lintian error in d/copyright
  * Disable openmpi support and keep pthread support (Closes: #738540)
  * Disable octave interface due to FTBFS  

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Sun, 23 Feb 2014 19:16:25 +0200

mathgl (2.2-1) unstable; urgency=low

  * Imported Upstream version 2.2
  * Disable documentation building in order to avoid FTBFS on some arches
  * Disable Lua interface
  * Drop symbols files (Closes: #701320, #701651)

 -- Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>  Fri, 10 Jan 2014 12:29:27 +0200
